#ifndef _H_DE13042A81E51E8A5B9CD0D0B25CEFAB_TestTopicServiceRequest_DCPS_H_
#define _H_DE13042A81E51E8A5B9CD0D0B25CEFAB_TestTopicServiceRequest_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TestTopicServiceRequest_.h"


namespace swri_roscpp
{
    namespace msg
    {
        namespace dds_
        {
            class TestTopicServiceRequest_TypeSupportInterface;

            typedef TestTopicServiceRequest_TypeSupportInterface * TestTopicServiceRequest_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceRequest_TypeSupportInterface> TestTopicServiceRequest_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceRequest_TypeSupportInterface> TestTopicServiceRequest_TypeSupportInterface_out;


            class TestTopicServiceRequest_DataWriter;

            typedef TestTopicServiceRequest_DataWriter * TestTopicServiceRequest_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceRequest_DataWriter> TestTopicServiceRequest_DataWriter_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceRequest_DataWriter> TestTopicServiceRequest_DataWriter_out;


            class TestTopicServiceRequest_DataReader;

            typedef TestTopicServiceRequest_DataReader * TestTopicServiceRequest_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceRequest_DataReader> TestTopicServiceRequest_DataReader_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceRequest_DataReader> TestTopicServiceRequest_DataReader_out;


            class TestTopicServiceRequest_DataReaderView;

            typedef TestTopicServiceRequest_DataReaderView * TestTopicServiceRequest_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceRequest_DataReaderView> TestTopicServiceRequest_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceRequest_DataReaderView> TestTopicServiceRequest_DataReaderView_out;

            struct TestTopicServiceRequest_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TestTopicServiceRequest_, struct TestTopicServiceRequest_Seq_uniq_> TestTopicServiceRequest_Seq;
            typedef DDS_DCPSSequence_var < TestTopicServiceRequest_Seq> TestTopicServiceRequest_Seq_var;
            typedef DDS_DCPSSequence_out < TestTopicServiceRequest_Seq> TestTopicServiceRequest_Seq_out;

            class  TestTopicServiceRequest_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TestTopicServiceRequest_TypeSupportInterface_ptr _ptr_type;
                typedef TestTopicServiceRequest_TypeSupportInterface_var _var_type;

                static TestTopicServiceRequest_TypeSupportInterface_ptr _duplicate (TestTopicServiceRequest_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceRequest_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceRequest_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TestTopicServiceRequest_TypeSupportInterface () {};
                ~TestTopicServiceRequest_TypeSupportInterface () {};
            private:
                TestTopicServiceRequest_TypeSupportInterface (const TestTopicServiceRequest_TypeSupportInterface &);
                TestTopicServiceRequest_TypeSupportInterface & operator = (const TestTopicServiceRequest_TypeSupportInterface &);
            };

            class  TestTopicServiceRequest_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TestTopicServiceRequest_DataWriter_ptr _ptr_type;
                typedef TestTopicServiceRequest_DataWriter_var _var_type;

                static TestTopicServiceRequest_DataWriter_ptr _duplicate (TestTopicServiceRequest_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceRequest_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceRequest_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TestTopicServiceRequest_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TestTopicServiceRequest_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TestTopicServiceRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceRequest_& instance_data) = 0;

            protected:
                TestTopicServiceRequest_DataWriter () {};
                ~TestTopicServiceRequest_DataWriter () {};
            private:
                TestTopicServiceRequest_DataWriter (const TestTopicServiceRequest_DataWriter &);
                TestTopicServiceRequest_DataWriter & operator = (const TestTopicServiceRequest_DataWriter &);
            };

            class  TestTopicServiceRequest_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TestTopicServiceRequest_DataReader_ptr _ptr_type;
                typedef TestTopicServiceRequest_DataReader_var _var_type;

                static TestTopicServiceRequest_DataReader_ptr _duplicate (TestTopicServiceRequest_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceRequest_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceRequest_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestTopicServiceRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestTopicServiceRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceRequest_& instance) = 0;

            protected:
                TestTopicServiceRequest_DataReader () {};
                ~TestTopicServiceRequest_DataReader () {};
            private:
                TestTopicServiceRequest_DataReader (const TestTopicServiceRequest_DataReader &);
                TestTopicServiceRequest_DataReader & operator = (const TestTopicServiceRequest_DataReader &);
            };

            class  TestTopicServiceRequest_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TestTopicServiceRequest_DataReaderView_ptr _ptr_type;
                typedef TestTopicServiceRequest_DataReaderView_var _var_type;

                static TestTopicServiceRequest_DataReaderView_ptr _duplicate (TestTopicServiceRequest_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceRequest_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceRequest_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceRequest_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestTopicServiceRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestTopicServiceRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestTopicServiceRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceRequest_& instance) = 0;

            protected:
                TestTopicServiceRequest_DataReaderView () {};
                ~TestTopicServiceRequest_DataReaderView () {};
            private:
                TestTopicServiceRequest_DataReaderView (const TestTopicServiceRequest_DataReaderView &);
                TestTopicServiceRequest_DataReaderView & operator = (const TestTopicServiceRequest_DataReaderView &);
            };
        }

    }

}

#endif
